#version 150 core

uniform mat4 viewProjectionMatrix;
uniform vec3 boundingBox[8];
uniform vec3 color;

out VERT_OUT {
    vec4 boundingBox[8];
    vec3 drawColor;
} vert_out;

void main() {
	// вершины AABB можно нарисовать в геометрическом шейдере при помощи triangle_strip и индексов: 3, 2, 6, 7, 4, 2, 0, 3, 1, 6, 5, 4, 1, 0
	vert_out.boundingBox[ 0 ] = viewProjectionMatrix * vec4( boundingBox[ 0 ], 1.0f );
	vert_out.boundingBox[ 1 ] = viewProjectionMatrix * vec4( boundingBox[ 1 ], 1.0f );
	vert_out.boundingBox[ 2 ] = viewProjectionMatrix * vec4( boundingBox[ 2 ], 1.0f );
	vert_out.boundingBox[ 3 ] = viewProjectionMatrix * vec4( boundingBox[ 3 ], 1.0f );
	vert_out.boundingBox[ 4 ] = viewProjectionMatrix * vec4( boundingBox[ 4 ], 1.0f );
	vert_out.boundingBox[ 5 ] = viewProjectionMatrix * vec4( boundingBox[ 5 ], 1.0f );
	vert_out.boundingBox[ 6 ] = viewProjectionMatrix * vec4( boundingBox[ 6 ], 1.0f );
	vert_out.boundingBox[ 7 ] = viewProjectionMatrix * vec4( boundingBox[ 7 ], 1.0f );

	vert_out.drawColor = color;
}
