#version 150 core
#extension GL_ARB_explicit_attrib_location: enable

layout( location = 0 ) in vec3 inVertex;
layout( location = 1 ) in vec3 inTextureCoord;


uniform mat4 modelViewProjectionMatrix;
// проверка видимости
uniform bool checkVisibility;
uniform samplerBuffer culledObjectBuffer;
uniform int objectIndex;
uniform uint objectId;

void main() {
	// отсекаем объект только в случае совпадения его идентификатора с отсеченным объектом
	if ( checkVisibility && uint( texelFetch( culledObjectBuffer, objectIndex ).r ) == objectId ) {
		// выносим вершину за пределы видимости камеры, таким образом фрагменты для нее не сформируются
		gl_Position = vec4( 2.0, 2.0, 2.0, 1.0 );
		return;
	}
	gl_Position  = modelViewProjectionMatrix * vec4( inVertex, 1.0f );
}
